#ifndef BYTEBUFFER_H
#define BYTEBUFFER_H
#include "common.h"

class ByteBuffer {
public:
	void put(char c);
	void putInt(int32_t l);
	void putLong(int64_t l);
	void put(Array<char> *array);
	int64_t getLong();
	int32_t getInt();
	char get();
	void get(Array<char> *array);
	void position(int32_t newPosition);
	Array<char> *array();
private:
	ByteBuffer(Array<char> *array);
	friend ByteBuffer *ByteBuffer_wrap(Array<char> *array);
	friend ByteBuffer *ByteBuffer_allocate(uint size);
	Array<char> *buffer;
	uint offset;
};
ByteBuffer *ByteBuffer_wrap(Array<char> *array);
ByteBuffer *ByteBuffer_allocate(uint size);
#endif
